(function() {
	var $storage = {
		LANGUAGE: "language",
		FONTSIZE: "fontSize",
		AGREEAGREEMENT: "agreeAgreement",
		TOKEN: "token",
		PHONE: "phone",
		USERINFO: "userInfo",
		REGISTRATIONID: "registrationId", // 极光推送id
		SEARCHHISTORY: "searchhistory", //本地搜索历史记录
		BEFORELOGINNAME: "beforeLoginName", //登录前页面名字
		BEFOREOPENWINNAME: "beforeOpenWinName", //之前打开的页面名字
		SETCARTSELECTID: "setCartSelectId", //存储购物车选择的id
		ISCHECKAGREEMENT: "isCheckAgreement" //是否点击过已同意协议-登录
	};

	var $api = (function() {
		// (function (window) {
		var u = {};
		// var isAndroid = (/android/gi).test(navigator.appVersion);
		// var uzStorage = function () {
		//   var ls = window.localStorage;
		//   if (isAndroid) {
		//     ls = os.localStorage();
		//   }
		//   return ls;
		// };
		u.setStorage = function(key, value) {
			if (arguments.length === 2) {
				var v = value;
				if (typeof v == "object") {
					v = JSON.stringify(v);
					v = "obj-" + v;
				} else {
					v = "str-" + v;
				}
				api.setPrefs({
					key: key,
					value: v
				});
			}
		};
		u.getStorage = function(key) {
			var ls = api.getPrefs({
				sync: true,
				key: key
			});

			// console.log(JSON.stringify(ls));
			if (ls) {
				if (ls.indexOf("obj-") === 0) {
					ls = ls.slice(4);
					return JSON.parse(ls);
				} else if (ls.indexOf("str-") === 0) {
					// console.log(ls.slice(4));
					return ls.slice(4);
				}
			} else {
				return;
			}
		};
		u.rmStorage = function(key) {
			api.removePrefs({
				key: key
			});
		};
		u.clearStorage = function() {
			var ls = uzStorage();
			if (ls) {
				ls.clear();
			}
		};

		(u.log = function(json) {
			console.log(JSON.stringify(json));
		}),
			(u.isArray = function(obj) {
				if (Array.isArray) {
					return Array.isArray(obj);
				} else {
					return obj instanceof Array;
				}
			});
		u.isEmptyObject = function(obj) {
			// if (JSON.stringify(obj) === '{}') {
			for (var attr in obj) {
				return false;
			}
			return true;
		};
		u.append = function(el, html) {
			if (!u.isElement(el)) {
				console.warn(
					"$api.append Function need el param, el param must be DOM Element"
				);
				return;
			}
			el.insertAdjacentHTML("beforeend", html);
			return el;
		};
		u.html = function(el, html) {
			if (!u.isElement(el)) {
				console.warn(
					"$api.html Function need el param, el param must be DOM Element"
				);
				return;
			}
			if (arguments.length === 1) {
				return el.innerHTML;
			} else if (arguments.length === 2) {
				el.innerHTML = html;
				return el;
			}
		};
		u.setStatusBarStyle = function(style) {
			api.setStatusBarStyle({
				style: style,
				color: "transparent"
			});
		};
		u.fixStatusBar = function(h, el) {
			if (!u.isDefine(el)) {
				el = document.querySelector("header");
			}
			if (!u.isElement(el)) {
				console.warn(
					"$api.fixStatusBar Function need el param, el param must be DOM Element"
				);
				return 0;
			}
			var height = $api.getPageFz(h);
			var top = api.safeArea.top;
			el.style.height = height + "px";
			el.style.paddingTop = top + "px";
			return height + top;
		};
		u.fixTabBar = function(h, el) {
			if (!u.isDefine(el)) {
				el = document.querySelector("footer");
			}
			if (!u.isElement(el)) {
				console.warn(
					"$api.fixTabBar Function need el param, el param must be DOM Element"
				);
				return 0;
			}
			var height = $api.getPageFz(h);
			var bottom = api.safeArea.bottom;
			el.style.height = height + "px";
			el.style.paddingBottom = bottom + "px";
			return height + bottom;
		};

		u.remove = function(el) {
			if (el && el.parentNode) {
				el.parentNode.removeChild(el);
			}
		};
		u.isElement = function(obj) {
			return !!(obj && obj.nodeType == 1);
		};
		u.offset = function(el) {
			if (!u.isElement(el)) {
				console.warn(
					"$api.offset Function need el param, el param must be DOM Element"
				);
				return;
			}
			var sl = Math.max(
				document.documentElement.scrollLeft,
				document.body.scrollLeft
			);
			var st = Math.max(
				document.documentElement.scrollTop,
				document.body.scrollTop
			);

			var rect = el.getBoundingClientRect();
			return {
				l: rect.left + sl,
				t: rect.top + st,
				w: el.offsetWidth,
				h: el.offsetHeight
			};
		};
		u.openWin = function(name, params, slidBackEnabled) {
			console.log(name);
			console.log(slidBackEnabled);
			if (!this.isJson(params)) {
				params = {};
			}
			api.openWin({
				name: name,
				url: "widget://pages/" + name + "/" + name + ".stml",
				pageParam: params,
				slidBackEnabled: slidBackEnabled,
				slidBackType: "edge",
				useWKWebView: true,
				reload: false
			});
		};
		u.openFrame = function(safeAreaBottom, addTop, allowEdit, softInputMode) {
			// console.log(api.winName);

			var header = document.querySelector("header");
			var header_h = 0;
			if (header) {
				header_h = $api.offset(header).h;
			}
			var body_h = api.winHeight;
			if (!$api.isDefine(safeAreaBottom)) {
				safeAreaBottom = 0;
			}
			if ($api.isDefine(addTop)) {
				addTop = -1;
			} else {
				addTop = 0;
			}
			var isAllowEdit = false;
			if ($api.isDefine(allowEdit)) {
				isAllowEdit = allowEdit;
			}
			var softInput = "auto";
			if ($api.isDefine(softInputMode)) {
				softInput = softInputMode;
			}
			api.openFrame({
				name: api.winName + "_frm",
				url: "widget://html/" + api.winName + "_frm.html",
				rect: {
					marginTop: header_h + addTop,
					marginBottom: safeAreaBottom,
					w: "auto"
				},

				bgColor: "#F6F7FA",
				pageParam: api.pageParam,
				vScrollBarEnabled: false,
				useWKWebView: true,
				reload: false,
				allowEdit: isAllowEdit,
				softInputMode: softInput
			});
		};
		//判断是否json对象
		u.isJson = function(obj) {
			var isjson =
				typeof obj == "object" &&
				Object.prototype.toString.call(obj).toLowerCase() == "[object object]" &&
				!obj.length;
			return isjson;
		};
		//判断变量是否定义
		u.isDefine = function(value) {
			if (
				value == null ||
				value == "" ||
				value == "undefined" ||
				value == undefined ||
				value == "null" ||
				value == "(null)" ||
				value == "NULL" ||
				typeof value == "undefined"
			) {
				return false;
			} else {
				value = value + "";
				value = value.replace(/\s/g, "");
				if (value == "") {
					return false;
				}
				return true;
			}
		};
		// 检测手机号
		u.testTel = function(val, error) {
			if (!/^[0-9]{9,11}$/.test(val)) {
				$api.toast(error);
				return false;
			} else {
				return true;
			}
		};

		// 检测密码
		u.testPwd = function(val, text) {
			// if (!(/^(?![0-9]+$)(?![a-zA-Z]+$)(?!([^(0-9a-zA-Z)]|[\(\)])+$)([^(0-9a-zA-Z)]|[\(\)]|[a-zA-Z]|[0-9]){6,16}$/.test(val))) {
			// if (!(/^(?![0-9]+$)(?![a-zA-Z]+$)(?!([^(0-9a-zA-Z)])+$)([^(0-9a-zA-Z)]|[a-zA-Z]|[0-9]){6,16}$/.test(val))) {
			if (!/^[A-Za-z0-9.*[~!@#$%^&*()_+`\-={}:";'<>?,.\/]{6,20}$/.test(val)) {
				// 字母或者数字或者组合
				if (text) {
					$api.toast(text);
				} else {
					$api.toast("密码需为6-20位字母数字或字符");
				}
				return false;
			} else {
				return true;
			}
		};
		// 检测身份证号
		u.testCard = function(val) {
			if (!/(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/.test(val)) {
				$api.toast("身份证格式错误！");
				return false;
			} else {
				return true;
			}
		};

		// 检测是否只有中英文
		u.testZhAndEn = function(val) {
			if (!/^[a-zA-Z\u4e00-\u9fa5]{1,20}$/.test(val)) {
				return false;
			} else {
				return true;
			}
		};

		// 检测邮箱
		u.testEmail = function(val) {
			if (val.indexOf("@") == -1) {
				$api.toast("请输入正确的邮箱格式");
				return false;
			} else {
				return true;
			}
		};

		u.toast = function(msg) {
			// console.log(api.frameName);
			api.toast({
				msg: msg,
				duration: 1500,
				location: "middle"
			});
		};
		//loading框
		u.showProgress = function(title, msg) {
			title = title ? title : "正在加载";
			msg = msg ? msg : "";
			api.showProgress({
				style: "default",
				animationType: "zoom",
				title: title,
				text: msg,
				modal: true
			});
		};

		//loading框
		u.showLoading = function() {
			var arr = [];
			var json = {};
			for (var i = 1; i <= 61; i++) {
				var json = {
					frame: "widget://image/loading/" + i + ".png"
				};

				arr.push(json);
			}
			var activity = api.require("UILoading");
			activity.keyFrame({
				rect: {
					w: 80,
					h: 80
				},

				styles: {
					bg: "rgba(0,0,0,0.5)",
					corner: 5,
					interval: 20,
					frame: {
						w: 60,
						h: 60
					}
				},

				content: arr,
				mask: "rgba(0,0,0,0)"
			});
		};
		u.closeLoading = function() {
			var uiloading = api.require("UILoading");
			uiloading.closeKeyFrame();
		};

		u.post = function(url, data) {
			return new Promise(function(resolve, reject) {
				api.ajax(
					{
						url: url,
						method: "post",
						timeout: 30,
						dataType: "json",
						data: {
							values: data
						}
					},

					function(ret, err) {
						// console.log(JSON.stringify(ret));
						if (ret) {
							$api.removeCls($api.byId("app"), "nointernet");
							var nointernet = document.querySelector("#nointernet");
							if (nointernet) {
								$api.remove(nointernet);
							}
							if (ret.status == 40004) {
								$api.logoutHandle(ret.msg);
							} else if (ret.status == 40003) {
								$api.logoutHandle(ret.msg);
							} else if (ret.status == 40002) {
								$api.logoutHandle(ret.msg);
							} else if (ret.status == 40001) {
								$api.logoutHandle(ret.msg);
							} else {
								resolve(ret);
							}
						} else {
							// callback(err)
							console.log("这是错误的返回" + JSON.stringify(err));
							// api.refreshHeaderLoadDone();
							$api.closeLoading();
							if (err.statusCode == 0) {
								console.log(err.statusCode);
								// var connectionType = api.connectionType;
								// if (connectionType == 'none' || connectionType == 'unknown') {
								// console.log(connectionType);
								var nointernet = document.getElementById("#nointernet");
								if (!nointernet) {
									var globalCtx = $api.getPageLanguageConfig("global");
									if (api.winName == "root") {
										var code =
											'<div id="nointernet" class="nodata full"><div class="icon"><img src="../image/nodata/no-internet.png" alt="nointernet"><p class="fz14 c999">' +
											globalCtx.nodata_4 +
											'</p><div class="refresh fz14 position-rel" onclick="$api.refresh()">' +
											globalCtx.refresh +
											"</div></div></div>";
									} else {
										var code =
											'<div id="nointernet" class="nodata full"><div class="icon"><img src="../image/nodata/no-internet.png" alt="nointernet"><p class="fz14 c999">' +
											globalCtx.nodata_4 +
											'</p><div class="refresh fz14 position-rel" onclick="$api.refresh()">' +
											globalCtx.refresh +
											"</div></div></div>";
									}
									$api.addCls($api.byId("app"), "nointernet");
									$api.append(document.getElementsByClassName("body"), code);
								}
							} else {
								$api.toast(err.msg);
							}
						}
						// }
					}
				);
			});
		};

		// u.unableLocation = function() {
		//   api.refreshHeaderLoadDone();
		//   api.hideProgress();
		//   var nointernet = document.querySelector("#nointernet");
		//   if (!nointernet) {
		//     if (api.winName == 'root') {
		//       var code =
		//         '<div id="nointernet" class="nodata full"><div class="icon"><img src="../image/nodata/3.png" alt="nointernet"><p class="fz32 font-r c777">无法定位</p><div class="refresh fz32" onclick="$api.refresh()">刷新</div></div></div>';
		//     } else {
		//       var code =
		//         '<div id="nointernet" class="nodata full"><div class="icon"><img src="../image/nodata/3.png" alt="nointernet"><p class="fz32 font-r c777">无法定位</p><div class="refresh fz32" onclick="$api.refresh()">刷新</div></div></div>';
		//     }
		//     $api.addCls($api.byId('app'), 'nointernet');
		//     $api.append(document.querySelector("body"), code);
		//   }
		// };

		u.logoutHandle = function(msg) {
			u.getPostErrorText(msg);
			console.log(JSON.stringify(msg));
			$api.rmStorage($storage.TOKEN);
			$api.rmStorage($storage.PHONE);
			$api.rmStorage($storage.MEIQIACLIENTID);
			$api.rmStorage($storage.AGREEMENTCONTENT);
			$api.rmStorage($storage.BEFORELOGINNAME);
			$api.send($eventType.LOGOUTSUCCESS);
			var winName = api.winName;
			setTimeout(function() {
				if (winName == "login") {
					$api.closeLoading();
				} else {
					api.closeToWin({
						name: "login"
					});

					// $api.openWin('login_trigger');
				}
			}, 1000);
		};

		u.addCls = function(el, cls) {
			if (!u.isElement(el)) {
				console.warn(
					"$api.addCls Function need el param, el param must be DOM Element"
				);
				return;
			}
			if ("classList" in el) {
				el.classList.add(cls);
			} else {
				var preCls = el.className;
				var newCls = preCls + " " + cls;
				el.className = newCls;
			}
			return el;
		};
		u.removeCls = function(el, cls) {
			if (!u.isElement(el)) {
				console.warn(
					"$api.removeCls Function need el param, el param must be DOM Element"
				);
				return;
			}
			if ("classList" in el) {
				el.classList.remove(cls);
			} else {
				var preCls = el.className;
				var newCls = preCls.replace(cls, "");
				el.className = newCls;
			}
			return el;
		};
		u.byId = function(id) {
			return document.getElementById(id);
		};
		u.getConnectionType = function() {
			if (api.connectionType == "none" || api.connectionType == "unknown");
			else {
				var nointernet = document.querySelector("#nointernet");
				if (nointernet) {
					$api.remove(nointernet);
				}
			}
		};
		u.formatTime = function(value, type) {
			if (value && value.toString().indexOf("-") == -1) {
				var dataTime = "";
				var data = new Date();
				data.setTime(value);
				var year = data.getFullYear();
				var month =
					data.getMonth() + 1 >= 10
						? data.getMonth() + 1
						: "0" + (data.getMonth() + 1);
				var day = data.getDate() >= 10 ? data.getDate() : "0" + data.getDate();
				var hour = data.getHours() >= 10 ? data.getHours() : "0" + data.getHours();
				var minute =
					data.getMinutes() >= 10 ? data.getMinutes() : "0" + data.getMinutes();
				var second =
					data.getSeconds() >= 10 ? data.getSeconds() : "0" + data.getSeconds();
				if (type == "YMD") {
					dataTime = year + "." + month + "." + day;
				} else if (type == "YMDHMS") {
					dataTime =
						year + "-" + month + "." + day + " " + hour + ":" + minute + ":" + second;
				} else if (type == "YMDHM") {
					dataTime = year + "." + month + "." + day + " " + hour + ":" + minute;
				} else if (type == "HMS") {
					dataTime = hour + ":" + minute + ":" + second;
				} else if (type == "HM") {
					dataTime = hour + ":" + minute;
				} else if (type == "YM") {
					dataTime = year + "." + month;
				}
				return dataTime; //将格式化后的字符串输出到前端显示
			} else {
				return value;
			}
		};

		u.refresh = function() {
			window.location.reload(true);
		};

		u.unopened = function() {
			u.toast("暂未开放");
		};

		u.lisViewappear = function(style) {
			api.addEventListener(
				{
					name: "viewappear"
				},
				function(ret, err) {
					$api.setStatusBarStyle(style);
				}
			);
		};
		// 适配iPhone X底部
		u.addSafeBottom = function() {
			var el = document.querySelector(".add-safe-bottom");
			if (el) {
				document.querySelectorAll(".add-safe-bottom").forEach(function(item) {
					item.style.paddingBottom = api.safeArea.bottom + "px";
				});
			} else {
				console.log("add-safe-bottom class不存在，请添加");
			}
		};

		u.paramsName = {
			camera: "相机",
			contacts: "通讯录",
			microphone: "麦克风",
			photos: "相册",
			location: "定位",
			locationAlways: "后台定位", // 只支持iOS
			notification: "通知", // iOS不支持跳转应用设置界面
			calendar: "日历", // 只支持Android
			phone: "电话", // 只支持Android
			sensor: "传感器", // 只支持Android
			sms: "短信", // 只支持Android
			storage: "存储空间" // 只支持Android
		};

		// 检测应用是否有某个或多个权限
		u.hasPermission = function(perm) {
			// console.log(perm);
			var resultList = api.hasPermission({
				list: [perm]
			});

			// console.log(JSON.stringify(resultList));
			if (resultList[0].granted) {
				return 1; // 有权限
			} else {
				if (
					(api.systemType == "android" && $api.getStorage("stop" + perm)) ||
					(api.systemType == "ios" && !resultList[0].undetermined)
				) {
					return 3; // 拒绝，跳转设置页面
				} else {
					return 2; // 可以请求权限
				}
			}
		};

		// 向系统请求某个或多个权限
		u.requestPermission = function(perm, callback) {
			api.requestPermission(
				{
					list: [perm],
					code: 1
				},
				function(res, err) {
					console.log(JSON.stringify(res));
					if (res.list[0].granted) {
						callback && callback(true);
					} else {
						if (api.systemType == "android" && res.never) {
							$api.setStorage("stop" + perm, "1");
						}
						callback && callback(false);
					}
				}
			);
		};

		u.confirmPer = function(perm, callback) {
			var has = $api.hasPermission1(perm);
			// console.log(JSON.stringify(has));
			if (!has || !has[0] || !has[0].granted) {
				$api.reqPermission(perm, callback);
				if (!callback) {
					return false;
				}
			}
			if (callback) {
				callback(true);
			} else {
				return true;
			}
		};

		u.hasPermission1 = function(perm) {
			var perms = new Array();
			perms.push(perm);
			var rets = api.hasPermission({
				list: perms
			});

			return rets;
		};

		u.reqPermission = function(perm, callback) {
			api.requestPermission(
				{
					list: [perm],
					code: 1
				},
				function(res, err) {
					// console.log(JSON.stringify(res));
					if (res.list[0].granted) {
						callback && callback(true);
					} else {
						if (api.systemType == "android" && res.never) {
							$api.setStorage("stop" + perm, "1");
						}
						callback && callback(false);
					}
				}
			);
		};

		u.premConfirm = function(perm, callback) {
			var globalCtx = $api.getPageLanguageConfig("global");
			$api.confirm(
				$api.paramsName[perm] + "-" + globalCtx.service_no,
				globalCtx.to_setting,
				[globalCtx.cancel, globalCtx.right],
				function(index) {
					callback && callback(index);
				}
			);
		};

		u.confirm = function(title, msg, buttons, callback) {
			api.confirm(
				{
					title: title,
					msg: msg,
					buttons: buttons
				},
				function(ret, err) {
					callback && callback(ret.buttonIndex);
				}
			);
		};

		u.UIActionSelector = function(data, col, title, buttons, callback) {
			var UIActionSelector = api.require("UIActionSelector");
			UIActionSelector.open(
				{
					datas: data,
					layout: {
						row: 5,
						col: col,
						height: 32,
						size: 15,
						sizeActive: 18,
						rowSpacing: 8,
						colSpacing: 10,
						maskBg: "rgba(0,0,0,0.4)",
						bg: "#fff",
						color: "#A4ABB0",
						colorActive: "#333333",
						colorSelected: "#333333"
					},

					bgCorner: 0,
					animation: true,
					cancel: {
						text: buttons[0],
						size: 15,
						w: 55,
						h: 35,
						bg: "#fff",
						bgActive: "#fff",
						color: "#999",
						colorActive: "#999"
					},

					ok: {
						text: buttons[1],
						size: 15,
						w: 55,
						h: 35,
						bg: "#fff",
						bgActive: "#fff",
						color: "#1EADFF",
						colorActive: "#1EADFF"
					},

					title: {
						text: title,
						size: 15,
						h: 50,
						bg: "#fff",
						color: "#333"
					},

					lineColor: "#EDEDED", //api.systemType == 'ios' ? 0.5 : 1
					lineHeight: api.systemType == "ios" ? 0.5 : 1,
					selectorDividerColor: "rgba(0,0,0,0)",
					selectedBold: false
				},
				function(ret, err) {
					if (ret) {
						// console.log(JSON.stringify(ret));
						if (ret.eventType == "ok") {
							callback(ret);
						}
					}
				}
			);
		};

		// 时间选择器
		u.UIDatePicker = function(
			type,
			title,
			date,
			maxDate,
			minDate,
			buttons,
			callback
		) {
			console.log(minDate);
			var UIDatePicker = api.require("UIDatePicker");
			UIDatePicker.open(
				{
					type: type,
					rowHeight: 40,
					date: date,
					minDate: minDate,
					maxDate: maxDate,
					title: title,
					hideIndicator: true,
					styles: {
						bg: "rgba(255,255,255,1)",
						headerViewBackgroundColor: "rgba(255,255,255,1)",
						lineBackgroundColor: "#EDEDED",
						item: {
							normal: "rgba(0,0,0,0.8)",
							normalFont: 15,
							selected: "#333",
							selectedFont: 18,
							cancelBtn: {
								cancelButtonTextColor: "#72757A",
								cancelButtonText: buttons[0],
								cancelButtonFont: 15
							},

							confirmBtn: {
								confirmButtonTextColor: "#1EADFF",
								confirmButtonText: buttons[1],
								confirmButtonFont: 15
							}
						}
					}
				},

				function(ret, err) {
					console.log(JSON.stringify(ret));
					if (ret.eventType == "submit") {
						if (ret.month) {
							var month = String(ret.month);
							if (month.length == 1) {
								month = "0" + month;
								ret.month = month;
							}
						}
						if (ret.day) {
							var day = String(ret.day);
							if (day.length == 1) {
								day = "0" + day;
								ret.day = day;
							}
						}
						if (ret.hour || ret.hour === 0) {
							var hour = String(ret.hour);
							if (hour.length == 1) {
								hour = "0" + hour;
								ret.hour = hour;
							}
						}
						if (ret.minute || ret.minute === 0) {
							var minute = String(ret.minute);
							console.log(minute);
							if (minute.length == 1) {
								minute = "0" + minute;
								ret.minute = minute;
							}
						}
						if (ret.seconds || ret.seconds === 0) {
							var seconds = String(ret.seconds);
							if (seconds.length == 1) {
								seconds = "0" + seconds;
								ret.seconds = seconds;
							}
						}
						callback(ret);
					}
				}
			);
		};

		// 判断app退到后台是否超过一定的时间
		u.pauseAndResumeToRefresh = function(callback, time) {
			time = time ? time * 1000 : 300000;
			api.addEventListener(
				{
					name: "pause"
				},
				function(ret, err) {
					api.setPrefs({
						key: "pauseTime",
						value: new Date().getTime()
					});
				}
			);

			api.addEventListener(
				{
					name: "resume"
				},
				function(ret, err) {
					var pauseTime = api.getPrefs({
						sync: true,
						key: "pauseTime"
					});

					var resumeTime = new Date().getTime();
					if (resumeTime - pauseTime > time) {
						callback(true);
					} else {
						callback(false);
					}
				}
			);
		};

		u.focusAndKeyboard = function(el) {
			setTimeout(function() {
				// document.querySelector(el).focus();
				document.getElementById("search").focus();
			}, 1000);
		};

		u.toFixed2 = function(num) {
			num = num.toString();
			if (num == "0.00") {
				return 0;
			}
			num = num.replace(/[^\d.]/g, "");
			num = num.replace(/^\./g, "");
			num = num.replace(/\.{2,}/g, "");
			num = num
				.replace(".", "$#$")
				.replace(/\./g, "")
				.replace("$#$", ".");
			num = num.replace(/^(\-)*(\d+)\.(\d\d).*$/, "$1$2.$3");
			if (num.length >= 2) {
				if (num.indexOf(".") == -1) {
					num = parseInt(num);
				}
			}
			return num;
		};

		u.toFixed1 = function(num) {
			num = num.toString();
			if (num == "0.0") {
				return 0;
			}
			num = num.replace(/[^\d.]/g, "");
			num = num.replace(/^\./g, "");
			num = num.replace(/\.{2,}/g, "");
			num = num
				.replace(".", "$#$")
				.replace(/\./g, "")
				.replace("$#$", ".");
			num = num.replace(/^(\-)*(\d+)\.(\d).*$/, "$1$2.$3");
			if (num.length >= 2) {
				if (num.indexOf(".") == -1) {
					num = parseInt(num);
				}
			}
			return num;
		};

		u.toFixed0 = function(num) {
			num = num.replace(/[^\d]/g, "");
			return num;
		};

		// 拨打电话
		u.callPhone = function(title, tel, type) {
			$api.confirmPer("phone", function(res) {
				if (res) {
					if (type == 1) {
						api.call({
							type: "tel",
							number: tel
						});
					} else {
						if (api.systemType == "ios") {
							api.call({
								type: "tel_prompt",
								number: tel
							});
						} else {
							$api.dialogBox.confirm(title, tel, ["取消", "拨打"], function(index) {
								if (index == 2) {
									api.call({
										type: "tel",
										number: tel
									});
								}
							});
						}
					}
				}
			});
		};

		u.isFirstOpen = function() {
			var isFirst = api.getPrefs({
				sync: true,
				key: "firstOpen"
			});

			if ($api.isDefine(isFirst)) {
				return false;
			} else {
				return true;
			}
		};

		u.decrypt = function(val) {
			var aseKey = api.loadSecureValue({
				sync: true,
				key: "aseKey"
			});

			var decrypt = CryptoJS.DES.decrypt(val, CryptoJS.enc.Utf8.parse(aseKey), {
				mode: CryptoJS.mode.ECB,
				padding: CryptoJS.pad.Pkcs7
			}).toString(CryptoJS.enc.Utf8);
			return decrypt;
		};

		// 数字转中文
		u.numToChinese = function(section) {
			var chnNumChar = [
				"零",
				"一",
				"二",
				"三",
				"四",
				"五",
				"六",
				"七",
				"八",
				"九"
			];
			var chnUnitChar = ["", "十", "百", "千"];
			var strIns = "",
				chnStr = "";
			var unitPos = 0;
			var zero = true;
			while (section > 0) {
				var v = section % 10;
				if (v === 0) {
					if (!zero) {
						zero = true;
						chnStr = chnNumChar[v] + chnStr;
					}
				} else {
					zero = false;
					strIns = chnNumChar[v];
					strIns += chnUnitChar[unitPos];
					chnStr = strIns + chnStr;
				}
				unitPos++;
				section = Math.floor(section / 10);
			}
			return chnStr;
		};

		u.getPageFz = function(size) {
			var fz = $api.getStorage("fontSize");
			return Math.floor((fz / 75.0) * size);
		};

		u.getRect = function(el, callback) {
			var search = document.querySelector(el);
			var rect = {
				x: $api.offset(search).l,
				y: $api.offset(search).t,
				w: $api.offset(search).w,
				h: $api.offset(search).h
			};

			console.log(JSON.stringify(rect));
			if (rect.x == 0 || rect.h == 0) {
				setTimeout(function() {
					$api.getRect(el, callback);
				}, 50);
			} else {
				callback(rect);
			}
		};

		u.openUIInput = function(
			rect,
			styles,
			maxStringLength,
			autoFocus,
			placeholder,
			keyboardType,
			fixedOn,
			fixed,
			callback
		) {
			var params = {
				rect: rect,
				styles: styles,
				maxStringLength: maxStringLength,
				autoFocus: autoFocus,
				placeholder: placeholder,
				keyboardType: keyboardType,
				fixedOn: fixedOn,
				fixed: fixed
			};

			// console.log(JSON.stringify(params));
			var UIInput = api.require("UIInput");
			UIInput.open(params, function(ret) {
				callback(ret, UIInput);
			});
		};

		u.getQueryString = function(key, url) {
			var reg = new RegExp("(^|&)" + key + "=([^&]*)(&|$)");
			var index = url.indexOf("?") + 1;
			var result = url.substr(index).match(reg);
			return result ? decodeURIComponent(result[2]) : null;
		};

		// 批量上传图片
		var UIAlbumBrowser_imgs = 0,
			UIAlbumBrowser_imgList = [],
			UIAlbumBrowser_imgIndex = 0;
		u.openUIAlbumBrowser = function(num, filetypes, callback) {
			var UIAlbumBrowser = api.require("UIAlbumBrowser");
			UIAlbumBrowser.open(
				{
					type: "image",
					max: num,
					styles: {
						bg: "#fff",
						mark: {
							icon: "",
							position: "top_right",
							size: 20
						},

						nav: {
							bg: "rgba(0,0,0,0.6)",
							titleColor: "#fff",
							titleSize: 18,
							cancelColor: "#fff",
							cancelSize: 16,
							finishColor: "#fff",
							finishSize: 16
						}
					}
				},

				function(ret, err) {
					if (ret) {
						if (ret.eventType == "confirm") {
							UIAlbumBrowser_imgs = ret.list.length;
							UIAlbumBrowser_imgList = ret.list;
							UIAlbumBrowser_imgIndex = 0;
							$api.showLoading();
							if (api.systemType == "ios") {
								that.UIAlbumBrowser_compress = function(index) {
									UIAlbumBrowser.transPath(
										{
											path: UIAlbumBrowser_imgList[index].path
										},
										function(ret, err) {
											// console.log(JSON.stringify(ret));
											if (ret) {
												u.compress(ret.path, filetypes, callback);
											}
										}
									);
								};
								that.UIAlbumBrowser_compress(UIAlbumBrowser_imgIndex);
							} else {
								that.UIAlbumBrowser_compress = function(index) {
									u.compress(UIAlbumBrowser_imgList[index].path, filetypes, callback);
								};
								that.UIAlbumBrowser_compress(UIAlbumBrowser_imgIndex);
								// for (var i = 0; i < ret.list.length; ++i) {}
							}
						}
					}
				}
			);
		};

		u.compress = function(path, filetypes, callback) {
			var Caches = api.cacheDir;
			//console.log(Caches);
			var imageFilter = api.require("imageFilter");
			imageFilter.getAttr(
				{
					path: path
				},
				function(ret, err) {
					if (ret.status) {
						// console.log(JSON.stringify(ret));
						var scale = 1;
						if (ret.width > 1000) {
							scale = 1000 / ret.width;
						}
						var name = new Date().getTime() + ".jpg";
						imageFilter.compress(
							{
								img: path,
								quality: 1,
								scale: scale,
								save: {
									album: false,
									imgPath: Caches,
									imgName: "1234567.jpg"
								}
							},

							function(ret, err) {
								//alert(JSON.stringify(ret));
								if (ret.status) {
									//alert(JSON.stringify(ret));
									u.uploadImg(Caches + "/1234567.jpg", filetypes, callback, "multi");
								} else {
									alert(JSON.stringify(err) + "图片压缩失败，请重试");
									$api.closeLoading();
								}
							}
						);
					} else {
						alert(JSON.stringify(err) + "获取图片信息失败，请重试");
						$api.closeLoading();
					}
				}
			);
		};

		u.uploadImg = function(path, filetypes, callback, multi) {
			api.ajax(
				{
					url: $config.uploadFile,
					method: "post",
					data: {
						values: {
							token: $api.getStorage($storage.TOKEN),
							filetypes: filetypes
						},

						files: {
							file: path
						}
					}
				},

				function(res, err) {
					if (res) {
						$api.removeCls($api.byId("app"), "nointernet");
						var nointernet = document.querySelector("#nointernet");
						if (nointernet) {
							$api.remove(nointernet);
						}
						if (res.status == 1) {
							callback(res.img_url);
						} else {
							callback("");
							$api.getPostErrorText(res.msg);
							$api.closeLoading();
						}
						if (multi) {
							if (++UIAlbumBrowser_imgIndex < UIAlbumBrowser_imgs) {
								// api.showProgress({
								//   title: '上传第' + (UIAlbumBrowser_imgIndex + 1) + '张',
								//   text: '共有' + UIAlbumBrowser_imgs + '张',
								// });
								$api.showLoading();
								that.UIAlbumBrowser_compress(UIAlbumBrowser_imgIndex);
							} else {
								$api.closeLoading();
							}
						}
					} else {
						api.refreshHeaderLoadDone();
						$api.closeLoading();
						if (err.statusCode == 0) {
							console.log(err.statusCode);
							// var connectionType = api.connectionType;
							// if (connectionType == 'none' || connectionType == 'unknown') {
							// console.log(connectionType);
							var nointernet = document.querySelector("#nointernet");
							if (!nointernet) {
								var globalCtx = $api.getPageLanguageConfig("global");
								if (api.winName == "root") {
									var code =
										'<div id="nointernet" class="nodata full"><div class="icon"><img src="../image/nodata/no-internet.png" alt="nointernet"><p class="fz14 c999">' +
										globalCtx.nodata_4 +
										'</p><div class="refresh fz14 position-rel" onclick="$api.refresh()">' +
										globalCtx.refresh +
										"</div></div></div>";
								} else {
									var code =
										'<div id="nointernet" class="nodata full"><div class="icon"><img src="../image/nodata/no-internet.png" alt="nointernet"><p class="fz14 c999">' +
										globalCtx.nodata_4 +
										'</p><div class="refresh fz14 position-rel" onclick="$api.refresh()">' +
										globalCtx.refresh +
										"</div></div></div>";
								}
								$api.addCls($api.byId("app"), "nointernet");
								$api.append(document.querySelector("body"), code);
							}
							// } else {
							//   $api.toast(err.msg);
							// }
						}
					}
				}
			);
		};

		// 获取单张图片上传
		u.getSingleImg = function(isUpload, callback) {
			var globalCtx = $api.getPageLanguageConfig("global");
			api.actionSheet(
				{
					cancelTitle: globalCtx.cancel,
					buttons: [globalCtx.camera, globalCtx.library]
				},
				function(ret, err) {
					if (ret.buttonIndex >= 3) {
						return;
					}
					var type = null;
					if (ret.buttonIndex === 1) {
						type = "camera";
					} else {
						type = "photos";
					}
					$api.confirmPer(type, function(res) {
						if (res) {
							api.getPicture(
								{
									sourceType: type,
									encodingType: "jpg",
									mediaValue: "pic",
									destinationType: "url",
									targetWidth: 1000,
									quality: 100
								},
								function(ret, err) {
									if (ret) {
										if (ret.data) {
											if (isUpload) {
												$api.uploadImg(ret.data, "User", function(url) {
													callback(url);
												});
											} else {
												callback(ret.data);
											}
										}
									}
								}
							);
						}
					});
				}
			);
		};

		u.actionSheet = function(title, cancelTitle, buttons, callback) {
			api.actionSheet(
				{
					title: title,
					cancelTitle: cancelTitle,
					buttons: buttons
				},
				function(ret, err) {
					var index = ret.buttonIndex;
					callback(index);
				}
			);
		};

		// 拍照
		u.getImgForCamera = function(callback) {
			api.getPicture(
				{
					sourceType: "camera",
					encodingType: "jpg",
					mediaValue: "pic",
					destinationType: "url",
					targetWidth: 1000,
					quality: 100
				},
				function(ret, err) {
					if (ret) {
						if (ret.data) {
							$api.uploadImg(ret.data, "Goods", function(url) {
								callback(url);
							});
						}
					}
				}
			);
		};

		u.openActionSheetForUploadImg = function(globalCtx, callback) {
			api.actionSheet(
				{
					cancelTitle: globalCtx.cancel,
					buttons: [globalCtx.select_for_camera, globalCtx.select_for_photo]
				},
				function(ret, err) {
					var index = ret.buttonIndex;
					if (index == 1) {
						$api.confirmPer("camera", function(res) {
							if (res) {
								callback && callback(index);
							}
						});
					} else if (index == 2) {
						// if ($api.confirmPer('photos')) {
						//   callback && callback(index)
						// }
						$api.confirmPer("photos", function(res) {
							if (res) {
								callback && callback(index);
							}
						});
					}
				}
			);
		};

		// 生成随机数
		u.randomNumber = function(randomFlag, min, max) {
			var str = "",
				range = min,
				arr = [
					"0",
					"1",
					"2",
					"3",
					"4",
					"5",
					"6",
					"7",
					"8",
					"9",
					"a",
					"b",
					"c",
					"d",
					"e",
					"f",
					"g",
					"h",
					"i",
					"j",
					"k",
					"l",
					"m",
					"n",
					"o",
					"p",
					"q",
					"r",
					"s",
					"t",
					"u",
					"v",
					"w",
					"x",
					"y",
					"z",
					"A",
					"B",
					"C",
					"D",
					"E",
					"F",
					"G",
					"H",
					"I",
					"J",
					"K",
					"L",
					"M",
					"N",
					"O",
					"P",
					"Q",
					"R",
					"S",
					"T",
					"U",
					"V",
					"W",
					"X",
					"Y",
					"Z"
				];
			// 随机产生
			if (randomFlag) {
				range = Math.round(Math.random() * (max - min)) + min;
			}
			for (var i = 0; i < range; i++) {
				pos = Math.round(Math.random() * (arr.length - 1));
				str += arr[pos];
			}
			return str;
		};

		// 隐藏手机号中间4位
		u.hidePhoneNumber = function(tel) {
			tel = "" + tel;
			var reg = /(\d{3})\d{4}(\d{4})/;
			var tel1 = tel.replace(reg, "$1****$2");
			return tel1;
		};

		// 隐藏手机号中间4位
		u.hidePhoneNumber2 = function(tel) {
			var str = String(tel);
			var len = str.length;
			if (len >= 7) {
				var reg = str.slice(-7, -3);
				return str.replace(reg, "****");
			} else if (len < 7 && len >= 6) {
				//1234567
				var reg = str.slice(-4, -2);
				return str.replace(reg, "**");
			}
		};

		//时间节点转换 多少分钟之前，多少小时之前，多少天之前，  xx年xx月xx日 xx：xx
		u.timeago = function(dateTimeStamp) {
			//如果dateTimeStamp 为13位时间戳则不需要改变，如果是10位则需要补全13位
			var minute = 1000 * 60; //把分，时，天，周，半个月，一个月用毫秒表示
			var hour = minute * 60;
			var day = hour * 24;
			var now = new Date().getTime(); //获取当前时间毫秒
			var diffValue = now - dateTimeStamp; //时间差
			// console.log(diffValue);
			if (diffValue < 0) {
				return;
			}
			var minC = diffValue / minute; //计算时间差的分，时，天，周，月
			var hourC = diffValue / hour;
			var dayC = diffValue / day;
			// if (monthC >= 1 && monthC <= 3) {
			//   result = " " + parseInt(monthC) + "月前"
			// } else if (weekC >= 1 && weekC <= 3) {
			//   result = " " + parseInt(weekC) + "周前"
			// } else
			if (dayC >= 1 && dayC < 4) {
				result = " " + parseInt(dayC) + "天前";
			} else if (hourC >= 1 && hourC < 24) {
				result = " " + parseInt(hourC) + "小时前";
			} else if (minC >= 1 && minC < 60) {
				result = " " + parseInt(minC) + "分钟前";
			} else if (diffValue >= 0 && diffValue <= minute) {
				result = "1分钟前";
			} else {
				//以上条件都不满足后，用来输出年月日
				var datetime = new Date();
				datetime.setTime(dateTimeStamp);
				var Nyear = datetime.getFullYear();
				var Nmonth =
					datetime.getMonth() + 1 < 10
						? "0" + (datetime.getMonth() + 1)
						: datetime.getMonth() + 1;
				var Ndate =
					datetime.getDate() < 10 ? "0" + datetime.getDate() : datetime.getDate();
				var Nhour =
					datetime.getHours() < 10 ? "0" + datetime.getHours() : datetime.getHours();
				var Nminute =
					datetime.getMinutes() < 10
						? "0" + datetime.getMinutes()
						: datetime.getMinutes();
				var Nsecond =
					datetime.getSeconds() < 10
						? "0" + datetime.getSeconds()
						: datetime.getSeconds();
				result =
					Nyear + "年" + Nmonth + "月" + Ndate + "日" + " " + Nhour + ":" + Nminute;
			}
			return result;
		};

		// 吸顶效果
		u.funSticky = function() {
			var obj = document.getElementById("sticky-event");
			var ot = obj.offsetTop;
			document.onscroll = function() {
				var st = document.documentElement.scrollTop || document.body.scrollTop;
				obj.setAttribute("data-fixed", st >= ot ? "fixed" : "");
			};
		};

		u.getFixStatusBar = function(h) {
			return Math.floor($api.getPageFz(h) + api.safeArea.top);
		};

		u.getFixTabBar = function(h) {
			return Math.floor($api.getPageFz(h) + api.safeArea.bottom);
		};

		// 打开图片浏览器
		u.UIPhotoViewer = {
			open: function open(data, index, callback) {
				var UIPhotoViewer = api.require("UIPhotoViewer");
				UIPhotoViewer.open(
					{
						images: data,
						activeIndex: index,
						placeholderImg: "widget://image/default.png",
						bgColor: "#000"
					},
					function(ret, err) {
						if (ret) {
							callback && callback(ret);
						}
					}
				);
			},
			close: function close() {
				var UIPhotoViewer = api.require("UIPhotoViewer");
				UIPhotoViewer.close();
			}
		};

		// 登录分享
		u.qqPlus = {
			isInstalled: function isInstalled(callback) {
				var qqPlus = api.require("QQPlus");
				qqPlus.installed(function(ret, err) {
					callback(ret.status);
				});
			},
			login: function login(callback) {
				var qqPlus = api.require("QQPlus");
				qqPlus.login(function(ret, err) {
					if (ret.status) {
						var openid = ret.openId,
							accessToken = ret.accessToken;
						qqPlus.getUserInfo(function(ret, err) {
							if (ret.status) {
								var info = {};
								if (typeof ret.info == "object") {
									info = ret.info;
								} else {
									info = JSON.parse(ret.info);
								}
								info.openid = openid;
								callback && callback(info);
							}
						});
					}
				});
			},
			shareWebpage: function shareWebpage(
				type,
				title,
				description,
				thumb,
				contentUrl,
				callback
			) {
				var qqPlus = api.require("QQPlus");
				if (!thumb) {
					thumb = "";
				}
				qqPlus.shareNews(
					{
						url: contentUrl,
						title: title,
						description: description,
						imgUrl: thumb, // 网络路径
						type: type
					},
					function(ret, err) {
						// alert(JSON.stringify(err));
						callback(ret.status);
					}
				);
			},
			shareImage: function shareImage(type, title, description, img, callback) {
				var qqPlus = api.require("QQPlus");
				qqPlus.shareImage(
					{
						type: type,
						imgPath: img,
						title: title,
						description: description
					},
					function(ret, err) {
						callback(ret.status);
					}
				);
			}
		};

		u.wxPlus = {
			isInstalled: function isInstalled(callback) {
				var wxPlus = api.require("wxPlus");
				wxPlus.isInstalled(function(ret, err) {
					callback(ret.installed);
				});
			},
			login: function login(callback) {
				var wxPlus = api.require("wxPlus");
				wxPlus.auth({}, function(ret, err) {
					// alert(JSON.stringify(ret));
					if (ret.status) {
						wxPlus.getToken(
							{
								code: ret.code
							},
							function(ret, err) {
								// alert(JSON.stringify(ret));
								if (ret.status) {
									wxPlus.getUserInfo(
										{
											accessToken: ret.accessToken,
											openId: ret.openId
										},
										function(ret, err) {
											if (ret.status) {
												// ret.nickname = unescape(escape(str).replace(/\%uD.{3}/g, ''))
												callback && callback(ret);
											}
										}
									);
								}
							}
						);
					}
				});
			},
			shareWebpage: function shareWebpage(
				scene,
				title,
				description,
				thumb,
				contentUrl,
				callback
			) {
				var wxPlus = api.require("wxPlus");
				wxPlus.shareWebpage(
					{
						scene: scene,
						title: title,
						description: description,
						thumb: thumb, // 本地路径
						contentUrl: contentUrl
					},
					function(ret, err) {
						// console.log(JSON.stringify( ret ));
						if (ret.status) {
							callback(ret.status);
						}
					}
				);
			},
			shareImage: function shareImage(scene, url, callback) {
				var wxPlus = api.require("wxPlus");
				wxPlus.shareImage(
					{
						scene: scene,
						// thumb: url,
						contentUrl: url
					},
					function(ret, err) {
						callback(ret.status);
					}
				);
			}
		};

		// 微博登录分享
		u.weiboPlus = {
			isInstalled: function isInstalled(callback) {
				var weiboPlus = api.require("weiboPlus");
				weiboPlus.isInstalled(function(ret, err) {
					callback(ret.status);
				});
			},
			login: function login(callback) {
				var weiboPlus = api.require("weiboPlus");
				weiboPlus.auth(function(ret, err) {
					if (ret.status) {
						weiboPlus.getUserInfo(
							{
								userId: ret.userId,
								token: ret.token
							},
							function(ret, err) {
								if (ret.status) {
									var info = {};
									if (typeof ret.userInfo == "object") {
										info = ret.userInfo;
									} else {
										info = JSON.parse(ret.userInfo);
									}
									info.userId = userId;
									callback && callback(info);
								}
							}
						);
					}
				});
			},
			shareWebpage: function shareWebpage(
				text,
				title,
				description,
				thumb,
				contentUrl,
				callback
			) {
				var weiboPlus = api.require("weiboPlus");
				if (!thumb) {
					thumb = "";
				}
				weiboPlus.shareWebPage(
					{
						text: text,
						title: title,
						description: description,
						thumb: thumb, // 网络路径
						contentUrl: contentUrl
					},
					function(ret, err) {
						// alert(JSON.stringify(err));
						callback(ret.status);
					}
				);
			},
			shareImage: function shareImage(text, img, callback) {
				var weiboPlus = api.require("weiboPlus");
				weiboPlus.shareImage(
					{
						text: text,
						imageUrl: img
					},
					function(ret, err) {
						callback(ret.status);
					}
				);
			}
		};

		u.wechatPay = function(data, callback) {
			var stringA =
				"appid=" +
				data.appid +
				"&noncestr=" +
				data.nonce_str +
				"&package=Sign=WXPay&partnerid=" +
				data.mch_id +
				"&prepayid=" +
				data.prepay_id +
				"&timestamp=" +
				data.timeStamp;
			var stringSignTemp = stringA + "&key=" + data.key;
			var sign = $.md5(stringSignTemp).toUpperCase();
			var wxPayPlus = api.require("wxPayPlus");
			wxPayPlus.payOrder(
				{
					apiKey: data.appid,
					orderId: data.prepay_id,
					mchId: data.mch_id,
					nonceStr: data.nonce_str,
					timeStamp: data.timeStamp,
					package: "Sign=WXPay",
					sign: sign
				},
				function(ret, err) {
					callback(ret);
				}
			);
		};

		u.aliPay = function(data, callback) {
			// console.log("------------data------------")
			// console.log(JSON.stringify(data))
			var aliPayPlus = api.require("aliPayPlus");
			aliPayPlus.payOrder(
				{
					orderInfo: data
				},
				function(ret, err) {
					callback(ret);
				}
			);
		};

		// facebook分享
		u.facebook = {
			isInstalled: function isInstalled(callback) {
				var facebook = api.require("facebook");
				facebook.isInstalled(function(ret, err) {
					callback(ret.installed);
				});
			},
			shareLinked: function shareLinked(url, quote, callback) {
				var facebook = api.require("facebook");
				facebook.shareLinked(
					{
						url: url,
						quote: quote
					},
					function(ret, err) {
						callback(ret.status);
					}
				);
			}
		};

		// 图片裁减
		u.openFNImageClip = function(url, callback) {
			var FNImageClip = api.require("FNImageClip");
			FNImageClip.open(
				{
					rect: {
						x: 0,
						y: 0,
						w: api.winWidth,
						h: api.winHeight
					},

					srcPath: url,
					highDefinition: true,
					style: {
						mask: "rgba(0,0,0,.8)",
						clip: {
							w: 200,
							h: 200,
							x: (api.winWidth - 200) / 2,
							y: (api.winHeight - 200) / 2,
							borderColor: "#fff",
							borderWidth: 1
							// appearance: 'rectangle',
						}
					},

					mode: "image"
				},
				function(ret, err) {
					if (ret) {
						var button = api.require("UIButton");
						button.open(
							{
								rect: {
									x: 0,
									y: api.winHeight - api.safeArea.bottom - 50,
									w: api.winWidth,
									h: 50 + api.safeArea.bottom
								},

								title: {
									size: 16,
									normal: "完成"
								}
							},

							function(ret, err) {
								if (ret) {
									var id = ret.id;
									if (ret.eventType == "click") {
										FNImageClip.save(
											{
												destPath: api.cacheDir + "/1234567.jpg"
												// copyToAlbum: false,
												// quality: 1
											},
											function(ret, err) {
												if (ret) {
													callback(ret.destPath);
													FNImageClip.close();
													button.close({
														id: id
													});
												} else {
													alert(JSON.stringify(err));
												}
											}
										);
									}
								}
							}
						);
					}
				}
			);
		};

		// 经纬度  百度坐标转火星坐标(百度坐标转高德)
		u.baiduTomars = function(lon, lat) {
			var x_pi = (3.14159265358979324 * 3000.0) / 180.0;
			var mars_point = {
				lon: 0,
				lat: 0
			};

			var x = lon - 0.0065;
			var y = lat - 0.006;
			var z = Math.sqrt(x * x + y * y) - 0.00002 * Math.sin(y * x_pi);
			var theta = Math.atan2(y, x) - 0.000003 * Math.cos(x * x_pi);
			mars_point.lon = z * Math.cos(theta);
			mars_point.lat = z * Math.sin(theta);
			return mars_point;
		};

		u.dialogBox = {
			alert: function alert(title, msg, buttons, callback) {
				var dialogBox = api.require("dialogBox");
				dialogBox.alert(
					{
						texts: {
							title: title,
							content: msg,
							leftBtnTitle: buttons[0]
							// rightBtnTitle: buttons[1]
						},
						styles: {
							bg: "#fff",
							// maskBg: 'rgba(100, 100, 100, 0.36)',
							w: 300,
							corner: 7,
							title: {
								marginT: 20,
								titleSize: 18,
								titleColor: "#000"
							},

							content: {
								marginT: 0,
								marginB: 12,
								color: "#888",
								size: 15
							},

							left: {
								marginB: 0,
								marginL: 0,
								w: 300,
								h: 50,
								corner: 2,
								bg: "rgba(245,245,245,0)",
								color: "#1EADFF",
								size: 18
							},

							horizontalLine: {
								color: "#ddd",
								height: api.systemType == "ios" ? 0.5 : 1
							}
						}
					},

					function(ret) {
						if (ret.eventType == "left") {
							$api.dialogBox.close("alert");
							callback(1);
						}
					}
				);
			},
			confirm: function confirm(title, msg, buttons, callback) {
				var dialogBox = api.require("dialogBox");
				dialogBox.alert(
					{
						texts: {
							title: title,
							content: msg,
							leftBtnTitle: buttons[0],
							rightBtnTitle: buttons[1]
						},

						styles: {
							bg: "#fff",
							// maskBg: 'rgba(100, 100, 100, 0.36)',
							w: 270,
							corner: 7,
							title: {
								marginT: 20,
								titleSize: 18,
								titleColor: "#000"
							},

							content: {
								marginT: 20,
								marginB: 19,
								color: "#888",
								size: 15
							},

							left: {
								marginB: 0,
								marginL: 0,
								w: 135,
								h: 50,
								corner: 2,
								bg: "rgba(245,245,245,0)",
								color: "#000",
								size: 18
							},

							right: {
								marginB: 0,
								marginL: 0,
								w: 135,
								h: 50,
								corner: 2,
								bg: "rgba(245,245,245,0)",
								color: "#000",
								size: 18
							},

							horizontalLine: {
								color: "#ddd",
								height: api.systemType == "ios" ? 0.5 : 1
							},

							verticalLine: {
								color: "#ddd",
								width: api.systemType == "ios" ? 0.5 : 1
							}
						}
					},

					function(ret) {
						if (ret.eventType == "left") {
							callback(1);
						} else {
							callback(2);
						}
						$api.dialogBox.close("alert");
					}
				);
			},
			close: function close(dialogName) {
				var dialogBox = api.require("dialogBox");
				dialogBox.close({
					dialogName: dialogName
				});
			}
		};

		u.deepCopy = function(val) {
			return JSON.parse(JSON.stringify(val));
		};

		u.googleMap = {
			getLocation: function getLocation(callback) {
				var GoogleMap = api.require("googleMap");
				GoogleMap.getLocation(function(ret) {
					console.log(JSON.stringify(ret));
					if (ret.status) {
						callbakc && callback(ret);
					}
				});
			},
			getNameFromCoords: function getNameFromCoords(lon, lat, callback) {
				var GoogleMap = api.require("googleMap");
				GoogleMap.getNameFromCoords(
					{
						lon: lon,
						lat: lat
					},
					function(ret) {
						if (ret.status) {
							callback && callback(ret);
						} else {
							console.log("error");
						}
					}
				);
			}
		};

		// 下拉刷新
		u.setRefreshHeaderInfo = function(callback, text1, text2, bgColor) {
			api.setRefreshHeaderInfo(
				{
					loadingImg: "widget://image/placeloader.png",
					bgColor: bgColor,
					textColor: "#333",
					textDown: text1 + "...",
					textUp: text2 + "...",
					showTime: false
				},
				function(ret, err) {
					if (ret) {
						callback();
					}
				}
			);
		};

		(u.scrolltobottom = function(callback) {
			api.addEventListener(
				{
					name: "scrolltobottom",
					extra: {
						threshold: -50
					}
				},

				function(ret, err) {
					callback();
				}
			);
		}),
			// 经纬度  高德坐标转百度
			(u.gaodeFormatBaidu = function(gg_lon, gg_lat) {
				var X_PI = (Math.PI * 3000.0) / 180.0;
				var x = gg_lon,
					y = gg_lat;
				var z = Math.sqrt(x * x + y * y) + 0.00002 * Math.sin(y * X_PI);
				var theta = Math.atan2(y, x) + 0.000003 * Math.cos(x * X_PI);
				var bd_lon = z * Math.cos(theta) + 0.0065;
				var bd_lat = z * Math.sin(theta) + 0.006;
				return {
					lon: bd_lon,
					lat: bd_lat
				};
			});

		// des加密
		u.encrypt = function(val) {
			var aseKey = api.loadSecureValue({
				sync: true,
				key: "codeAseKey"
			});

			var encrypt = CryptoJS.DES.encrypt(val, CryptoJS.enc.Utf8.parse(aseKey), {
				mode: CryptoJS.mode.ECB,
				padding: CryptoJS.pad.Pkcs7
			});

			var encryptText = encrypt.toString();
			return encryptText;
		};

		// 验证码加密
		u.encryptCode = function(tel) {
			var text = api.appId + "," + tel + "," + Date.parse(new Date()) / 1000;
			return $api.encrypt(text);
		};

		// 判断数组是否含有重复的元素
		u.hasSameForArray = function(arr) {
			return /(\x0f[^\x0f]+)\x0f[\s\S]*\1/.test(
				"\x0f" + arr.join("\x0f\x0f") + "\x0f"
			);
		};

		// 多语言项目判断当前语言并返回对应的语言包
		u.getPageLanguageConfig = function(value) {
			// console.log($api.getStorage($storage.LANGUAGE));
			var pack = eval("language_pack." + value);
			var zh = {};
			var my = {};
			var en = {};
			Object.keys(pack).forEach(function(item) {
				zh[item] = pack[item].zh;
				my[item] = pack[item].my;
				en[item] = pack[item].en;
			});
			// console.log(JSON.stringify(zh))
			// console.log(JSON.stringify(it))
			if ($api.getStorage($storage.LANGUAGE) == "zh-CN") {
				return zh;
			} else if ($api.getStorage($storage.LANGUAGE) == "my-MM") {
				return my;
			} else {
				return en;
			}
		};

		// 根据当前的语言弹出对应的toast
		u.getPostErrorText = function(val) {
			if ($api.getStorage($storage.LANGUAGE) == "zh-CN") {
				$api.toast(val.zh_cn);
			} else if ($api.getStorage($storage.LANGUAGE) == "my-MM") {
				$api.toast(val.my_mm);
			} else {
				$api.toast(val.en_us);
			}
		};

		// 根据当前的语言返回
		u.getNameForLanguage = function(zh, en) {
			if ($api.getStorage($storage.LANGUAGE) == "zh-CN") {
				return zh;
			} else {
				return en;
			}
		};

		// 游客模式触发登录
		u.visitorNeedLogin = function(winName) {
			$api.setStorage($storage.BEFORELOGINNAME, winName);
			$api.openWin(
				"login_visitor",
				{
					title: "登录"
				},
				false
			);
		};

		u.getDistanceByLonAndLat = function(lat1, lng1, lat2, lng2) {
			var radLat1 = (lat1 * Math.PI) / 180.0;
			var radLat2 = (lat2 * Math.PI) / 180.0;
			var a = radLat1 - radLat2;
			var b = (lng1 * Math.PI) / 180.0 - (lng2 * Math.PI) / 180.0;
			var s =
				2 *
				Math.asin(
					Math.sqrt(
						Math.pow(Math.sin(a / 2), 2) +
							Math.cos(radLat1) * Math.cos(radLat2) * Math.pow(Math.sin(b / 2), 2)
					)
				);
			s = s * 6378.137; // EARTH_RADIUS;
			s = Math.round(s * 10000) / 10000;
			s = s.toFixed(2);
			return s;
		};

		u.getRoundingNum = function(num) {
			var money = Number(num);
			money = math.number(
				math
					.chain(math.bignumber(money))
					.multiply(math.bignumber(0.1))
					.done()
			);
			money = parseInt(money);
			money = math.number(
				math
					.chain(math.bignumber(money))
					.multiply(math.bignumber(10))
					.done()
			);
			return money;
		};

		window.$api = u;
		return u;
	})();

	if (!Array.prototype.forEach) {
		Array.prototype.forEach = function(callback, thisArg) {
			var T, k;
			if (this == null) {
				throw new TypeError(" this is null or not defined");
			}
			var O = Object(this);
			var len = O.length >>> 0;
			if (typeof callback !== "function") {
				throw new TypeError(callback + " is not a function");
			}
			if (arguments.length > 1) {
				T = thisArg;
			}
			k = 0;
			while (k < len) {
				var kValue;
				if (k in O) {
					kValue = O[k];
					callback.call(T, kValue, k, O);
				}
				k++;
			}
		};
	}

	var Header = /*@__PURE__*/ (function(Component) {
		function Header(props) {
			Component.call(this, props);
		}

		if (Component) Header.__proto__ = Component;
		Header.prototype = Object.create(Component && Component.prototype);
		Header.prototype.constructor = Header;
		Header.prototype.back = function() {
			console.log("back");
		};
		Header.prototype.rightClick = function() {
			console.log("123123123");
		};
		Header.prototype.render = function() {
			return apivm.h(
				"safe-area",
				{class: "bg-fff"},
				apivm.h(
					"view",
					{class: "height-46 postion-rel"},
					apivm.h("view", {class: "bottom-line-1"}),
					apivm.h(
						"view",
						{class: " padding-left-15 padding-right-15 width-100p"},
						apivm.h(
							"view",
							{
								class:
									"flex flex-center-v flex-h width-100p disflex-h-space-between height-46"
							},

							this.props.leftType == "img"
								? apivm.h(
										"view",
										{class: "width-20 height-20"},
										apivm.h("img", {
											src: this.props.left_button,
											class: "width-20 height-20",
											onClick: this.props.onLeftClick ? this.props.onLeftClick : this.back
										})
								  )
								: null,
							this.props.leftType == "text"
								? apivm.h("view", null, apivm.h("text", null, this.props.left_button))
								: null,
							apivm.h(
								"text",
								{class: "fz18 title font-m height-46 width-100p flex flex-center"},
								this.props.title
							),

							this.props.rightType == "img"
								? apivm.h(
										"view",
										{class: "width-20 height-20"},
										apivm.h("img", {
											src: this.props.right_button,
											class: "width-20 height-20",
											onClick: this.props.onRightClick
												? this.props.onRightClick
												: this.rightClick
										})
								  )
								: null,
							this.props.rightType == "text"
								? apivm.h(
										"view",
										{class: ""},
										apivm.h(
											"text",
											{
												class: "fz14",
												onClick: this.props.onRightClick
													? this.props.onRightClick
													: this.rightClick
											},
											this.props.right_button
										)
								  )
								: null
						)
					)
				)
			);
		};

		return Header;
	})(Component);
	Header.css = {
		".title": {position: "absolute", top: "0", left: "0", zIndex: "-1"},
		".bg-fff": {backgroundColor: "#fff"},
		".disflex-h-space-between": {
			display: ["-webkit-box", "-ms-flexbox", "flex", "-webkit-flex"],
			WebkitBoxPack: "justify",
			msFlexPack: "justify",
			justifyContent: "space-between"
		},
		".bottom-line-1": {
			height: "2px",
			width: "100%",
			backgroundColor: "#e7e7e7",
			transform: "scaleY(.5)",
			position: "absolute",
			bottom: "0",
			left: "0"
		}
	};
	Header.csslink = ["../../../css/app.css"];
	apivm.define("header", Header);

	var Login = /*@__PURE__*/ (function(Component) {
		function Login(props) {
			Component.call(this, props);
			this.data = {
				language: "English",
				show_password: false,
				tel: "",
				password: ""
			};
		}

		if (Component) Login.__proto__ = Component;
		Login.prototype = Object.create(Component && Component.prototype);
		Login.prototype.constructor = Login;
		Login.prototype.install = function() {
			that = this;
			// api.setStatusBarStyle({
			//     style: "dark"
			// });
		};
		Login.prototype.apiready = function() {};
		Login.prototype.changePasswordType = function() {
			this.data.show_password = !this.data.show_password;
		};
		Login.prototype.leftClick = function() {
			console.log("left");
		};
		Login.prototype.rightClick = function() {
			that.openMain();
			// console.log("right");
		};
		Login.prototype.swiper = function() {
			$api.openWin("swiper");
		};
		Login.prototype.openMain = function() {
			api.closeWin();
		};
		Login.prototype.render = function() {
			var this$1 = this;
			return apivm.h(
				"view",
				{class: "page font-r flex"},
				apivm.h("header", {
					title: "登录",
					leftType: "img",
					rightType: "text",
					left_button: "../../image/icon-100.png",
					right_button: "随便看看",
					onLeftClick: this.leftClick,
					onRightClick: this.rightClick
				}),
				apivm.h(
					"view",
					{class: "position-rel flex-1 flex"},

					apivm.h(
						"view",
						{
							class:
								"height-76 flex-center flex-h disflex-h-space-between padding-left-30 padding-right-30"
						},
						apivm.h("view", {class: "flex-1"}),
						apivm.h(
							"view",
							{class: "flex-center flex-h"},
							apivm.h("text", {class: "fz16"}, this.data.language),
							apivm.h("img", {
								src: "../../image/icon-101.png",
								alt: "",
								class: "width-14 height-14 margin-left-5"
							})
						)
					),
					apivm.h(
						"view",
						{class: "padding-top-24 margin-left-15 margin-right-15"},

						apivm.h(
							"view",
							{
								class: "flex-center flex-1 flex-h flex-left height-56 fz16 position-rel"
							},
							apivm.h(
								"view",
								{class: "flex-center flex-h flex-left height-56"},
								apivm.h("text", {class: "width-81"}, "手机号"),
								apivm.h("text", {class: ""}, "+95")
							),
							apivm.h("input", {
								type: "text",
								class: "flex-1 margin-left-5 fz16",
								placeholder: "请输入手机号",
								maxlength: "11",
								onInput: function(e) {
									this$1.data.tel = e.target.value;
								},
								"keyboard-type": "tel",
								"confirm-hold": "next",
								value: this.data.tel
							}),
							apivm.h("view", {class: "bottom-line"})
						),

						apivm.h(
							"view",
							{
								class: "flex-center flex-1 flex-h flex-left height-56 fz16 position-rel"
							},
							apivm.h(
								"view",
								{class: "flex-center flex-h flex-left height-56"},
								apivm.h("text", {class: "width-81"}, "密码")
							),
							apivm.h("input", {
								type: this.data.show_password ? "text" : "password",
								class: "flex-1 margin-left-5 fz16",
								placeholder: "请输入密码",
								onInput: function(e) {
									this$1.data.password = e.target.value;
								},
								"confirm-hold": "done",
								value: this.data.password
							}),
							apivm.h("img", {
								src: this.data.show_password
									? "../../image/icon-105.png"
									: "../../image/icon-102.png",
								alt: "",
								onClick: function() {
									return this$1.changePasswordType();
								},
								class: "width-16 height-16"
							}),
							apivm.h("view", {class: "bottom-line"})
						)
					),
					apivm.h(
						"view",
						{
							class:
								"testbg padding-top-13 margin-left-15 margin-right-15 flex flex-center flex-h disflex-h-space-between fz14 c666"
						},
						apivm.h("text", {class: "c666 fz14"}, "验证码登录"),
						apivm.h("text", {class: "c666 fz14"}, "忘记密码？")
					),
					apivm.h(
						"view",
						{class: "margin-left-15 margin-right-15 margin-top-32"},
						apivm.h(
							"button",
							{
								type: "button",
								class:
									this.data.tel.length == 11
										? "login-button-style fz14 font-m c-fff"
										: "login-button-style-1 fz14 font-m c-fff",
								onClick: function() {
									return this$1.swiper();
								}
							},
							"登录"
						)
					),
					apivm.h(
						"view",
						{class: "fz14 margin-left-15 margin-top-15 flex flex-h"},
						apivm.h("text", {class: "c666 fz14"}, "还没有账号？"),
						apivm.h("text", {class: "c-FF5301 fz14"}, "点击注册")
					),
					apivm.h("view", {class: "flex-1"}),
					apivm.h(
						"view",
						{
							class:
								"margin-left-15 margin-right-15 flex flex-h flex-1 flex-center disflex-h-space-between"
						},
						apivm.h("view", {class: "flex-1 line height-1"}),
						apivm.h(
							"text",
							{class: "fz14 c666 margin-left-12 margin-right-12"},
							"第三方登录"
						),
						apivm.h("view", {class: "flex-1 line height-1"})
					),
					apivm.h(
						"view",
						{
							class:
								"flex flex-center flex-center-v flex-h margin-top-32 margin-bottom-61"
						},
						apivm.h("img", {
							src: "../../image/icon-103.png",
							alt: "",
							class: "width-45 height-45 margin-right-81"
						}),
						apivm.h("img", {
							src: "../../image/icon-104.png",
							alt: "",
							class: "width-45 height-45"
						})
					)
				)
			);
		};

		return Login;
	})(Component);
	Login.css = {
		".height-76": {height: "76px"},
		".testbg": {background: "rgb(243, 243, 4)"},
		".line": {borderBottom: "1px solid #eee"},
		input: {borderWidth: "0"},
		".login-button-style": {
			width: "100%",
			height: "40px",
			background: "rgb(252, 122, 1)",
			borderRadius: "20px",
			opacity: "1"
		},
		".login-button-style-1": {
			width: "100%",
			height: "40px",
			background: "rgb(252, 122, 1)",
			borderRadius: "20px",
			opacity: "0.5"
		},
		".disable": {opacity: "0.5"},
		".page": {height: "100%"},
		".language-style": {right: "15px", top: "30px"},
		".bottom-line": {
			height: "1px",
			width: "100%",
			backgroundColor: "#e7e7e7",
			transform: "scaleY(0.5)",
			position: "absolute",
			bottom: "0",
			left: "0"
		},
		".c666": {color: "#666666"},
		".c-fff": {color: "#ffffff"},
		".c-FF5301": {color: "#ff5301"}
	};
	Login.csslink = ["../../css/app.css"];
	apivm.define("login", Login);
	apivm.render(apivm.h("login", null), "body");
})();
